package se.swedsoft.bookkeeping.gui.util.dialogs;


import se.swedsoft.bookkeeping.gui.util.components.SSImagePanel;

import javax.swing.*;
import java.awt.event.*;


public class SSInputDialog extends JDialog {
    private JPanel contentPane;
    private JButton buttonOK;
    private JButton buttonCancel;
    private JTextField iIpAddressTextField;
    private SSImagePanel iImage;
    private static String iAddress;

    public SSInputDialog() {
        setLocation(400, 300);
        setContentPane(contentPane);
        setModal(true);
        getRootPane().setDefaultButton(buttonOK);
        setTitle("Välj server");
        buttonOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onOK();
            }
        });

        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        });

        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                onCancel();
            }
        });

        contentPane.registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0),
                JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
    }

    private void onOK() {
        iAddress = iIpAddressTextField.getText();
        dispose();
    }

    private void onCancel() {
        iAddress = null;
        dispose();
    }

    public static String showDialog() {
        SSInputDialog dialog = new SSInputDialog();

        dialog.pack();
        dialog.setVisible(true);
        return iAddress;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();

        sb.append("se.swedsoft.bookkeeping.gui.util.dialogs.SSInputDialog");
        sb.append("{buttonCancel=").append(buttonCancel);
        sb.append(", buttonOK=").append(buttonOK);
        sb.append(", contentPane=").append(contentPane);
        sb.append(", iImage=").append(iImage);
        sb.append(", iIpAddressTextField=").append(iIpAddressTextField);
        sb.append('}');
        return sb.toString();
    }
}
